package shark.arthas.demo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StopWatch;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.concurrent.TimeUnit;

/**
 * trace shark.arthas.demo.Sample03 handle --skipJDKMethod false
 * 新终端 2，使用telnet localhost 3658连接上
 * trace shark.arthas.demo.Sample03 methodB  --listenerId 3
 * trace shark.arthas.demo.Runner doStart  --listenerId 3
 * @author yuwc
 * @ClassName 定位方法执行耗时原因
 * @description: 定位方法执行耗时原因
 * @date 2024年03月21日
 * @version: 1.0
 */
@RestController
@RequestMapping("03")
public class Sample03 {
    @Autowired
    Runner runner;
    @RequestMapping("/useTime")
    public void handle() throws InterruptedException {
        StopWatch stopWatch = new StopWatch();
        stopWatch.start();
        methodA();
        methodB();
        stopWatch.stop();
    }
    private void methodA(){
        System.out.println("执行methodA");
    }
    private void methodB() throws InterruptedException {
        System.out.println("执行methodB");
        runner.doStart();
    }
}
@Component
class Runner{
    public void doStart() throws InterruptedException {
        TimeUnit.SECONDS.sleep(3);
    }
}
